/*
Beetle choke time extender 6/4/2016 Bernie Kobier.
developed for my duaghters '75 VW SupperBug L which was missing the thermostat as a result
on cold frosty mornings the engine would take longer to heat up than the choke would stay closed.
This program reads the current manifold temperature on power up and disconnects the power to the choke element
if the temperature is below 10 deg C. power to the choke remians off untill the manifold temp reaches 20deg or a mximum of 2minutes.
once the time is exceeded power is suplpied to the choke element which then opperates normally.

Dallas DS18B20 one wire temp sensor is used for temperature monitoring temperature monitoring code is modified from
http://www.pjrc.com/teensy/td_libs_OneWire.html 

*/
#include <OneWire.h>
OneWire  ds(10);  // on pin 10 (a 4.7K resistor is necessary)
  byte i;
  byte present = 0;
  byte type_s;
  byte data[12];
  byte addr[8];
  float celsius;
  unsigned long timeon;
  int choke = 8;

void setup() {
  // put your setup code here, to run once:
  pinMode(choke, OUTPUT);
  digitalWrite(choke, LOW);
  Serial.begin(9600);
  getSender();
  delay(500);
  StartConvert();
  delay(1000);
  ReadTemp();
  if (celsius < 10 ) {
    digitalWrite(choke, HIGH);
  }
  
}


void getSender() {
  if ( !ds.search(addr)) {
    Serial.println("No more addresses.");
    Serial.println();
    ds.reset_search();
    delay(250);
    return;
  }
  
  Serial.print("ROM =");
  for( i = 0; i < 8; i++) {
    Serial.write(' ');
    Serial.print(addr[i], HEX);
  }

  if (OneWire::crc8(addr, 7) != addr[7]) {
      Serial.println("CRC is not valid!");
      return;
  }
  Serial.println();
 
  // the first ROM byte indicates which chip
  switch (addr[0]) {
    case 0x10:
      Serial.println("  Chip = DS18S20");  // or old DS1820
      type_s = 1;
      break;
    case 0x28:
      Serial.println("  Chip = DS18B20");
      type_s = 0;
      break;
    case 0x22:
      Serial.println("  Chip = DS1822");
      type_s = 0;
      break;
    default:
      Serial.println("Device is not a DS18x20 family device.");
      return;
}
}

void StartConvert() {
  ds.reset();
  ds.select(addr);
  ds.write(0x44, 1);        // start conversion, with parasite power on at the end
}

void ReadTemp() {
  ds.reset();
  ds.select(addr);    
  ds.write(0xBE);
  for ( i = 0; i < 9; i++) {           // we need 9 bytes
    data[i] = ds.read();}

 // Convert the data to actual temperature
  // because the result is a 16 bit signed integer, it should
  // be stored to an "int16_t" type, which is always 16 bits
  // even when compiled on a 32 bit processor.
  int16_t raw = (data[1] << 8) | data[0];
  if (type_s) {
    raw = raw << 3; // 9 bit resolution default
    if (data[7] == 0x10) {
      // "count remain" gives full 12 bit resolution
      raw = (raw & 0xFFF0) + 12 - data[6];
    }
  else {
    byte cfg = (data[4] & 0x60);
    // at lower res, the low bits are undefined, so let's zero them
    if (cfg == 0x00) raw = raw & ~7;  // 9 bit resolution, 93.75 ms
    else if (cfg == 0x20) raw = raw & ~3; // 10 bit res, 187.5 ms
    else if (cfg == 0x40) raw = raw & ~1; // 11 bit res, 375 ms
    //// default is 12 bit resolution, 750 ms conversion time
  }
  }
   celsius = (float)raw / 16.0;
}
void loop() {
  // put your main code here, to run repeatedly:
  
  
  StartConvert();
  delay(1000);
  ReadTemp();
  
  Serial.print("  Temperature = ");
  Serial.print(celsius);
  Serial.println(" Celsius, ");
  timeon=millis();
  Serial.println(timeon);
  if (celsius > 20 || timeon > 120000) { // checks to see if the temp has exceeded 20deg or 2 minutes has passed since power on
    digitalWrite(choke, LOW); //negative logic is used to drive the relay so the relay is only active for the 2 minute start up time
  }
  
  
  
}
